JavaScript Data GridBatch operations

Batch CRUD operations, to avoid unnecessary rendering cycles and boost your grid's performance.

Overview

Within Handsontable, every CRUD operation ends with a render(). In most cases, this is considered expected behaviour. The table has to reflect the requested changes at some point. However, sometimes you may find this mechanism slightly excessive.

For example, if you wrote a custom function that uses several CRUD operations, those CRUD operations will call a render() for each API method. You only need one render at the end, which is sufficient to reflect all the changes. You can treat those combined operations as a single action and let the render wait for them to complete. To do this, use suspend the render to batch the operations.

This can improve the overall performance of the application. Batching several operations can decrease the number of renders, so any API call that ends with a render will benefit from this improvement. It results in less layout trashing, fewer freezes, and a more responsive feel.

There are several API methods you can use for suspending, but batch() is the most universal method. It is a callback function where the render() is executed after all operations provided inside of the body are completed. It is best practice to use this method as it's safer and easier to use. You just need to place all operations that you want to batch inside a closure. Handsontable takes care of the suspending and performs a single render() at the end.

The following snippet shows a simple example of a few operations batched. Three API operations are called one after another. Without placing them inside the batch callback, every single operation would end with a render(). Thanks to the batching feature, you can skip two renders and end the whole action with one render at the end. This is more optimal, and the gain increases with the number of operations placed inside the batch().

// call the batch method on an instance
hot.batch(() => {
  // run the operations as needed
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');
  hot.selectCell(0, 0);
  // the render is executed right after all of the operations are completed
});

Suspending the render results in better performance, which is especially noticeable when numerous operations are batched. The diagram shows a comparison where the same operations were performed with (deep blue columns) and without the batch (light blue columns). The gain in speed of execution time increases with the number of operations batched.

batch_operations_comparison

TIP

Note that other methods can be used to batch operations, but they are slightly more advanced and should be used with caution. Flickering, glitches or other visual distortion may happen when you forget to resume render after suspending it several times. Mixing methods of a render type with those focused on operations can also result in some unexpected behavior. Above all, batch() should be sufficient in most use cases, and it is safe to work with.

API methods

The following API methods allow suspending:

By using these methods, you can suspend:

  • rendering
  • execution
  • both rendering and the execution.

The term "rendering" refers directly to DOM rendering, and the term "execution" refers to all operations that are different from DOM rendering. Currently, only the indexing recalculation allows you to postpone the process.

Method names that are prefixed with batch\*, i.e., batch(), batchRender(), and batchExecution() are recommended to be used as the first choice if you don't need to batch async operations. Methods names that are prefixed with suspend\*, i.e., suspendRender() and suspendExecution(), are the second choice. These are useful when you need to batch async operations. Essentially they work the same way as batch\* methods, but the render has to be resumed manually.

batch* methods

batch

This method supsends both rendering and other operations. It is universal and especially useful if you want to batch multiple API calls within the application.

hot.batch(() => {
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');

  const filters = hot.getPlugin('filters');

  filters.addCondition(2, 'contains', ['3']);
  filters.filter();
  hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
  // The table cache will be recalculated, and table render will be called once after executing the callback
});

batchRender

The batchRender() method is a callback function. Excessive renders can be skipped by placing the API calls inside it. The table will be rendered after executing the callback. It is less prone to errors as you don't have to remember to resume the render. The only drawback to this method is that it doesn't support async operations.

hot.batchRender(() => {
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');
  // The table will be rendered once after executing the callback
});

batchExecution

The batchExecution() is a callback function. Excessive renders can be skipped by placing the API calls inside of it. The table will be rendered after executing the callback. It is less prone to errors as you don't have to remember to resume the operations. The only drawback to this method is that it doesn't support async operations.

hot.batchExecution(() => {
  const filters = hot.getPlugin('filters');

  filters.addCondition(2, 'contains', ['3']);
  filters.filter();
  hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
  // The table cache will be recalculated once after executing the callback
});

suspend* and resume* methods

suspendRender() and resumeRender()

To suspend the rendering process, call the suspendRender() method just before the actions you want to batch. This is a manual approach.

After suspending, resume the process with the resumeRender() method. Every suspendRender() call needs to correspond with one resumeRender() call. For example, if you call suspendRender() 5 times, you need to call resumeRender() 5 times as well.

hot.suspendRender(); // suspend rendering
hot.alter('insert_row_above', 5, 45);
hot.setDataAtCell(1, 1, 'x');
hot.resumeRender(); // remember to resume rendering

suspendExecution and resumeExecution

To suspend the rendering process, you can call the suspendExecution() method just before the actions you want to batch. This is a manual approach. After suspending, you must remember to resume the process with the resumeExecution() method.

hot.suspendExecution();
const filters = hot.getPlugin('filters');

filters.addCondition(2, 'contains', ['3']);
filters.filter();
hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
hot.resumeExecution(); // It updates the cache internally

Live demo of the suspend feature

The following examples show how much the batch() method can decrease the render time. Both of the examples share the same dataset and operations. The first one shows how much time lapsed when the batch() method was used. Run the second example to check how much time it takes to render without the batch() method.

Here you will see the log
import Handsontable from 'handsontable';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

const container = document.querySelector('#example1');
const buttonWithout = document.querySelector('#buttonWithout');
const buttonWith = document.querySelector('#buttonWith');
const output = document.querySelector('#output');
const data1 = [
  [1, 'Gary Nash', 'Speckled trousers', 'S', 1, 'yes'],
  [2, 'Gloria Brown', '100% Stainless sweater', 'M', 2, 'no'],
  [3, 'Ronald Carver', 'Sunny T-shirt', 'S', 1, 'no'],
  [4, 'Samuel Watkins', 'Floppy socks', 'S', 3, 'no'],
  [5, 'Stephanie Huddart', 'Bushy-bush cap', 'XXL', 1, 'no'],
  [6, 'Madeline McGillivray', 'Long skirt', 'L', 1, 'no'],
  [7, 'Jai Moor', 'Happy dress', 'XS', 1, 'no'],
  [8, 'Ben Lower', 'Speckled trousers', 'M', 1, 'no'],
  [9, 'Ali Tunbridge', 'Speckled trousers', 'M', 2, 'no'],
  [10, 'Archie Galvin', 'Regular shades', 'uni', 10, 'no'],
];

const data2 = [[11, 'Gavin Elle', 'Floppy socks', 'XS', 3, 'yes']];
const data3 = [
  [12, 'Gary Erre', 'Happy dress', 'M', 1, 'no'],
  [13, 'Anna Moon', 'Unicorn shades', 'uni', 200, 'no'],
  [14, 'Elise Eli', 'Regular shades', 'uni', 1, 'no'],
];

const hot = new Handsontable(container, {
  themeName: 'ht-theme-main',
  data: data1,
  width: 'auto',
  height: 'auto',
  colHeaders: ['ID', 'Customer name', 'Product name', 'Size', 'qty', 'Return'],
  autoWrapRow: true,
  autoWrapCol: true,
  licenseKey: 'non-commercial-and-evaluation',
});

const alterTable = () => {
  hot.alter('insert_row_above', 10, 10);
  hot.alter('insert_col_start', 6, 1);
  hot.populateFromArray(10, 0, data2);
  hot.populateFromArray(11, 0, data3);
  hot.setCellMeta(2, 2, 'className', 'green-bg');
  hot.setCellMeta(4, 2, 'className', 'green-bg');
  hot.setCellMeta(5, 2, 'className', 'green-bg');
  hot.setCellMeta(6, 2, 'className', 'green-bg');
  hot.setCellMeta(8, 2, 'className', 'green-bg');
  hot.setCellMeta(9, 2, 'className', 'green-bg');
  hot.setCellMeta(10, 2, 'className', 'green-bg');
  hot.alter('remove_col', 6, 1);
  hot.alter('remove_row', 10, 10);
  hot.setCellMeta(0, 5, 'className', 'red-bg');
  hot.setCellMeta(10, 5, 'className', 'red-bg');
  hot.render(); // Render is needed here to populate the new "className"s
};

let loggedText = '';
let counter = 0;
const logOutput = (msg) => {
  counter++;
  loggedText = `[${counter}] ${msg}\n${loggedText}`;
  output.innerText = loggedText;
};

buttonWithout.addEventListener('click', () => {
  const t1 = performance.now();

  alterTable();

  const t2 = performance.now();

  logOutput(`Time without batch ${(t2 - t1).toFixed(2)}ms`);
});
buttonWith.addEventListener('click', () => {
  const t1 = performance.now();

  hot.batch(alterTable);

  const t2 = performance.now();

  logOutput(`Time with batch ${(t2 - t1).toFixed(2)}ms`);
});

Angular Data GridBatch operations

Batch CRUD operations, to avoid unnecessary rendering cycles and boost your grid's performance.

Overview

Within Handsontable, every CRUD operation ends with a render(). In most cases, this is considered expected behaviour. The table has to reflect the requested changes at some point. However, sometimes you may find this mechanism slightly excessive.

For example, if you wrote a custom function that uses several CRUD operations, those CRUD operations will call a render() for each API method. You only need one render at the end, which is sufficient to reflect all the changes. You can treat those combined operations as a single action and let the render wait for them to complete. To do this, use suspend the render to batch the operations.

This can improve the overall performance of the application. Batching several operations can decrease the number of renders, so any API call that ends with a render will benefit from this improvement. It results in less layout trashing, fewer freezes, and a more responsive feel.

There are several API methods you can use for suspending, but batch() is the most universal method. It is a callback function where the render() is executed after all operations provided inside of the body are completed. It is best practice to use this method as it's safer and easier to use. You just need to place all operations that you want to batch inside a closure. Handsontable takes care of the suspending and performs a single render() at the end.

The following snippet shows a simple example of a few operations batched. Three API operations are called one after another. Without placing them inside the batch callback, every single operation would end with a render(). Thanks to the batching feature, you can skip two renders and end the whole action with one render at the end. This is more optimal, and the gain increases with the number of operations placed inside the batch().

TIP

To use the Handsontable API, you'll need access to the Handsontable instance. You can do that by utilizing a reference to the HotTable component, and reading its hotInstance property.

For more information, see the Instance access page.

// call the batch method on an instance
hot.batch(() => {
  // run the operations as needed
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');
  hot.selectCell(0, 0);
  // the render is executed right after all of the operations are completed
});

Suspending the render results in better performance, which is especially noticeable when numerous operations are batched. The diagram shows a comparison where the same operations were performed with (deep blue columns) and without the batch (light blue columns). The gain in speed of execution time increases with the number of operations batched.

batch_operations_comparison

TIP

Note that other methods can be used to batch operations, but they are slightly more advanced and should be used with caution. Flickering, glitches or other visual distortion may happen when you forget to resume render after suspending it several times. Mixing methods of a render type with those focused on operations can also result in some unexpected behavior. Above all, batch() should be sufficient in most use cases, and it is safe to work with.

API methods

The following API methods allow suspending:

By using these methods, you can suspend:

  • rendering
  • execution
  • both rendering and the execution.

The term "rendering" refers directly to DOM rendering, and the term "execution" refers to all operations that are different from DOM rendering. Currently, only the indexing recalculation allows you to postpone the process.

Method names that are prefixed with batch\*, i.e., batch(), batchRender(), and batchExecution() are recommended to be used as the first choice if you don't need to batch async operations. Methods names that are prefixed with suspend\*, i.e., suspendRender() and suspendExecution(), are the second choice. These are useful when you need to batch async operations. Essentially they work the same way as batch\* methods, but the render has to be resumed manually.

batch* methods

batch

This method supsends both rendering and other operations. It is universal and especially useful if you want to batch multiple API calls within the application.

hot.batch(() => {
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');

  const filters = hot.getPlugin('filters');

  filters.addCondition(2, 'contains', ['3']);
  filters.filter();
  hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
  // The table cache will be recalculated, and table render will be called once after executing the callback
});

batchRender

The batchRender() method is a callback function. Excessive renders can be skipped by placing the API calls inside it. The table will be rendered after executing the callback. It is less prone to errors as you don't have to remember to resume the render. The only drawback to this method is that it doesn't support async operations.

hot.batchRender(() => {
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');
  // The table will be rendered once after executing the callback
});

batchExecution

The batchExecution() is a callback function. Excessive renders can be skipped by placing the API calls inside of it. The table will be rendered after executing the callback. It is less prone to errors as you don't have to remember to resume the operations. The only drawback to this method is that it doesn't support async operations.

hot.batchExecution(() => {
  const filters = hot.getPlugin('filters');

  filters.addCondition(2, 'contains', ['3']);
  filters.filter();
  hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
  // The table cache will be recalculated once after executing the callback
});

suspend* and resume* methods

suspendRender() and resumeRender()

To suspend the rendering process, call the suspendRender() method just before the actions you want to batch. This is a manual approach.

After suspending, resume the process with the resumeRender() method. Every suspendRender() call needs to correspond with one resumeRender() call. For example, if you call suspendRender() 5 times, you need to call resumeRender() 5 times as well.

hot.suspendRender(); // suspend rendering
hot.alter('insert_row_above', 5, 45);
hot.setDataAtCell(1, 1, 'x');
hot.resumeRender(); // remember to resume rendering

suspendExecution and resumeExecution

To suspend the rendering process, you can call the suspendExecution() method just before the actions you want to batch. This is a manual approach. After suspending, you must remember to resume the process with the resumeExecution() method.

hot.suspendExecution();
const filters = hot.getPlugin('filters');

filters.addCondition(2, 'contains', ['3']);
filters.filter();
hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
hot.resumeExecution(); // It updates the cache internally

Live demo of the suspend feature

The following examples show how much the batch() method can decrease the render time. Both of the examples share the same dataset and operations. The first one shows how much time lapsed when the batch() method was used. Run the second example to check how much time it takes to render without the batch() method.

Here you will see the log
/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';

@Component({
  selector: 'example1-batch-operation',
  standalone: false,
  template: ` <div class="example-controls-container">
      <div class="controls">
        <button
          id="buttonWithout"
          class="button button--primary"
          (click)="buttonWithoutClick()"
        >
          Run without batch method
        </button>
        <button
          id="buttonWith"
          class="button button--primary"
          (click)="buttonWithClick()"
        >
          Run with batch method
        </button>
      </div>
      <output class="console" id="output">
        {{ output || 'Here you will see the log' }}
      </output>
    </div>
    <div>
      <hot-table [data]="dataInit" [settings]="gridSettings"></hot-table>
    </div>`,
})
export class Example1BatchOperationComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  dataInit = [
    [1, 'Gary Nash', 'Speckled trousers', 'S', 1, 'yes'],
    [2, 'Gloria Brown', '100% Stainless sweater', 'M', 2, 'no'],
    [3, 'Ronald Carver', 'Sunny T-shirt', 'S', 1, 'no'],
    [4, 'Samuel Watkins', 'Floppy socks', 'S', 3, 'no'],
    [5, 'Stephanie Huddart', 'Bushy-bush cap', 'XXL', 1, 'no'],
    [6, 'Madeline McGillivray', 'Long skirt', 'L', 1, 'no'],
    [7, 'Jai Moor', 'Happy dress', 'XS', 1, 'no'],
    [8, 'Ben Lower', 'Speckled trousers', 'M', 1, 'no'],
    [9, 'Ali Tunbridge', 'Speckled trousers', 'M', 2, 'no'],
    [10, 'Archie Galvin', 'Regular shades', 'uni', 10, 'no'],
  ];
  data2 = [[11, 'Gavin Elle', 'Floppy socks', 'XS', 3, 'yes']];
  data3 = [
    [12, 'Gary Erre', 'Happy dress', 'M', 1, 'no'],
    [13, 'Anna Moon', 'Unicorn shades', 'uni', 200, 'no'],
    [14, 'Elise Eli', 'Regular shades', 'uni', 1, 'no'],
  ];

  readonly gridSettings: GridSettings = {
    height: 'auto',
    width: 'auto',
    colHeaders: [
      'ID',
      'Customer name',
      'Product name',
      'Size',
      'qty',
      'Return',
    ],
    autoWrapRow: true,
    autoWrapCol: true
  };

  output!: string;
  counter = 0;

  buttonWithoutClick(): void {
    const t1 = performance.now();

    this.alterTable();

    const t2 = performance.now();

    this.logOutput(`Time without batch ${(t2 - t1).toFixed(2)}ms`);
  }

  buttonWithClick(): void {
    const hot = this.hotTable?.hotInstance;
    const t1 = performance.now();

    hot?.batch(() => this.alterTable());

    const t2 = performance.now();

    this.logOutput(`Time with batch ${(t2 - t1).toFixed(2)}ms`);
  }

  private alterTable(): void {
    const hot = this.hotTable?.hotInstance;

    hot?.alter('insert_row_above', 10, 10);
    hot?.alter('insert_col_start', 6, 1);
    hot?.populateFromArray(10, 0, this.data2);
    hot?.populateFromArray(11, 0, this.data3);
    hot?.setCellMeta(2, 2, 'className', 'green-bg');
    hot?.setCellMeta(4, 2, 'className', 'green-bg');
    hot?.setCellMeta(5, 2, 'className', 'green-bg');
    hot?.setCellMeta(6, 2, 'className', 'green-bg');
    hot?.setCellMeta(8, 2, 'className', 'green-bg');
    hot?.setCellMeta(9, 2, 'className', 'green-bg');
    hot?.setCellMeta(10, 2, 'className', 'green-bg');
    hot?.alter('remove_col', 6, 1);
    hot?.alter('remove_row', 10, 10);
    hot?.setCellMeta(0, 5, 'className', 'red-bg');
    hot?.setCellMeta(10, 5, 'className', 'red-bg');
    hot?.render(); // Render is needed here to populate the new "className"s
  }

  private logOutput(output: string): void {
    this.output = `[${this.counter}] ${output}\n${this.output ?? ''}`;
    this.counter = this.counter + 1;
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1BatchOperationComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1BatchOperationComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1BatchOperationComponent ]
})

export class AppModule { }

React Data GridBatch operations

Batch CRUD operations, to avoid unnecessary rendering cycles and boost your grid's performance.

Overview

Within Handsontable, every CRUD operation ends with a render(). In most cases, this is considered expected behaviour. The table has to reflect the requested changes at some point. However, sometimes you may find this mechanism slightly excessive.

For example, if you wrote a custom function that uses several CRUD operations, those CRUD operations will call a render() for each API method. You only need one render at the end, which is sufficient to reflect all the changes. You can treat those combined operations as a single action and let the render wait for them to complete. To do this, use suspend the render to batch the operations.

This can improve the overall performance of the application. Batching several operations can decrease the number of renders, so any API call that ends with a render will benefit from this improvement. It results in less layout trashing, fewer freezes, and a more responsive feel.

There are several API methods you can use for suspending, but batch() is the most universal method. It is a callback function where the render() is executed after all operations provided inside of the body are completed. It is best practice to use this method as it's safer and easier to use. You just need to place all operations that you want to batch inside a closure. Handsontable takes care of the suspending and performs a single render() at the end.

The following snippet shows a simple example of a few operations batched. Three API operations are called one after another. Without placing them inside the batch callback, every single operation would end with a render(). Thanks to the batching feature, you can skip two renders and end the whole action with one render at the end. This is more optimal, and the gain increases with the number of operations placed inside the batch().

TIP

To use the Handsontable API, you'll need access to the Handsontable instance. You can do that by utilizing a reference to the HotTable component, and reading its hotInstance property.

For more information, see the Instance methods page.

// call the batch method on an instance
hot.batch(() => {
  // run the operations as needed
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');
  hot.selectCell(0, 0);
  // the render is executed right after all of the operations are completed
});

Suspending the render results in better performance, which is especially noticeable when numerous operations are batched. The diagram shows a comparison where the same operations were performed with (deep blue columns) and without the batch (light blue columns). The gain in speed of execution time increases with the number of operations batched.

batch_operations_comparison

TIP

Note that other methods can be used to batch operations, but they are slightly more advanced and should be used with caution. Flickering, glitches or other visual distortion may happen when you forget to resume render after suspending it several times. Mixing methods of a render type with those focused on operations can also result in some unexpected behavior. Above all, batch() should be sufficient in most use cases, and it is safe to work with.

API methods

The following API methods allow suspending:

By using these methods, you can suspend:

  • rendering
  • execution
  • both rendering and the execution.

The term "rendering" refers directly to DOM rendering, and the term "execution" refers to all operations that are different from DOM rendering. Currently, only the indexing recalculation allows you to postpone the process.

Method names that are prefixed with batch\*, i.e., batch(), batchRender(), and batchExecution() are recommended to be used as the first choice if you don't need to batch async operations. Methods names that are prefixed with suspend\*, i.e., suspendRender() and suspendExecution(), are the second choice. These are useful when you need to batch async operations. Essentially they work the same way as batch\* methods, but the render has to be resumed manually.

batch* methods

batch

This method supsends both rendering and other operations. It is universal and especially useful if you want to batch multiple API calls within the application.

hot.batch(() => {
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');

  const filters = hot.getPlugin('filters');

  filters.addCondition(2, 'contains', ['3']);
  filters.filter();
  hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
  // The table cache will be recalculated, and table render will be called once after executing the callback
});

batchRender

The batchRender() method is a callback function. Excessive renders can be skipped by placing the API calls inside it. The table will be rendered after executing the callback. It is less prone to errors as you don't have to remember to resume the render. The only drawback to this method is that it doesn't support async operations.

hot.batchRender(() => {
  hot.alter('insert_row_above', 5, 45);
  hot.setDataAtCell(1, 1, 'x');
  // The table will be rendered once after executing the callback
});

batchExecution

The batchExecution() is a callback function. Excessive renders can be skipped by placing the API calls inside of it. The table will be rendered after executing the callback. It is less prone to errors as you don't have to remember to resume the operations. The only drawback to this method is that it doesn't support async operations.

hot.batchExecution(() => {
  const filters = hot.getPlugin('filters');

  filters.addCondition(2, 'contains', ['3']);
  filters.filter();
  hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
  // The table cache will be recalculated once after executing the callback
});

suspend* and resume* methods

suspendRender() and resumeRender()

To suspend the rendering process, call the suspendRender() method just before the actions you want to batch. This is a manual approach.

After suspending, resume the process with the resumeRender() method. Every suspendRender() call needs to correspond with one resumeRender() call. For example, if you call suspendRender() 5 times, you need to call resumeRender() 5 times as well.

hot.suspendRender(); // suspend rendering
hot.alter('insert_row_above', 5, 45);
hot.setDataAtCell(1, 1, 'x');
hot.resumeRender(); // remember to resume rendering

suspendExecution and resumeExecution

To suspend the rendering process, you can call the suspendExecution() method just before the actions you want to batch. This is a manual approach. After suspending, you must remember to resume the process with the resumeExecution() method.

hot.suspendExecution();
const filters = hot.getPlugin('filters');

filters.addCondition(2, 'contains', ['3']);
filters.filter();
hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
hot.resumeExecution(); // It updates the cache internally

Live demo of the suspend feature

The following examples show how much the batch() method can decrease the render time. Both of the examples share the same dataset and operations. The first one shows how much time lapsed when the batch() method was used. Run the second example to check how much time it takes to render without the batch() method.

Here you will see the log
import { useRef, useState } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  const [counter, setCounter] = useState(0);
  const [output, setOutput] = useState('');
  const data2 = [[11, 'Gavin Elle', 'Floppy socks', 'XS', 3, 'yes']];
  const data3 = [
    [12, 'Gary Erre', 'Happy dress', 'M', 1, 'no'],
    [13, 'Anna Moon', 'Unicorn shades', 'uni', 200, 'no'],
    [14, 'Elise Eli', 'Regular shades', 'uni', 1, 'no'],
  ];

  const logOutput = (msg) => {
    setCounter(counter + 1);
    setOutput(`[${counter}] ${msg}\n${output}`);
  };

  const alterTable = () => {
    const hot = hotRef.current?.hotInstance;

    hot?.alter('insert_row_above', 10, 10);
    hot?.alter('insert_col_start', 6, 1);
    hot?.populateFromArray(10, 0, data2);
    hot?.populateFromArray(11, 0, data3);
    hot?.setCellMeta(2, 2, 'className', 'green-bg');
    hot?.setCellMeta(4, 2, 'className', 'green-bg');
    hot?.setCellMeta(5, 2, 'className', 'green-bg');
    hot?.setCellMeta(6, 2, 'className', 'green-bg');
    hot?.setCellMeta(8, 2, 'className', 'green-bg');
    hot?.setCellMeta(9, 2, 'className', 'green-bg');
    hot?.setCellMeta(10, 2, 'className', 'green-bg');
    hot?.alter('remove_col', 6, 1);
    hot?.alter('remove_row', 10, 10);
    hot?.setCellMeta(0, 5, 'className', 'red-bg');
    hot?.setCellMeta(10, 5, 'className', 'red-bg');
    hot?.render(); // Render is needed here to populate the new "className"s
  };

  const buttonWithoutClickCallback = () => {
    const t1 = performance.now();

    alterTable();

    const t2 = performance.now();

    logOutput(`Time without batch ${(t2 - t1).toFixed(2)}ms`);
  };

  const buttonWithClickCallback = () => {
    const hot = hotRef.current?.hotInstance;
    const t1 = performance.now();

    hot?.batch(alterTable);

    const t2 = performance.now();

    logOutput(`Time with batch ${(t2 - t1).toFixed(2)}ms`);
  };

  return (
    <>
      <div className="example-controls-container">
        <div className="controls">
          <button id="buttonWithout" className="button button--primary" onClick={() => buttonWithoutClickCallback()}>
            Run without batch method
          </button>
          <button id="buttonWith" className="button button--primary" onClick={() => buttonWithClickCallback()}>
            Run with batch method
          </button>
        </div>
        <output className="console" id="output">
          {output || 'Here you will see the log'}
        </output>
      </div>
      <HotTable
        themeName="ht-theme-main"
        ref={hotRef}
        data={[
          [1, 'Gary Nash', 'Speckled trousers', 'S', 1, 'yes'],
          [2, 'Gloria Brown', '100% Stainless sweater', 'M', 2, 'no'],
          [3, 'Ronald Carver', 'Sunny T-shirt', 'S', 1, 'no'],
          [4, 'Samuel Watkins', 'Floppy socks', 'S', 3, 'no'],
          [5, 'Stephanie Huddart', 'Bushy-bush cap', 'XXL', 1, 'no'],
          [6, 'Madeline McGillivray', 'Long skirt', 'L', 1, 'no'],
          [7, 'Jai Moor', 'Happy dress', 'XS', 1, 'no'],
          [8, 'Ben Lower', 'Speckled trousers', 'M', 1, 'no'],
          [9, 'Ali Tunbridge', 'Speckled trousers', 'M', 2, 'no'],
          [10, 'Archie Galvin', 'Regular shades', 'uni', 10, 'no'],
        ]}
        width="auto"
        height="auto"
        colHeaders={['ID', 'Customer name', 'Product name', 'Size', 'qty', 'Return']}
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </>
  );
};

export default ExampleComponent;

Skip to content

Batch operations

Batch CRUD operations, to avoid unnecessary rendering cycles and boost your grid’s performance.

Overview

Within Handsontable, every CRUD operation ends with a render(). In most cases, this is considered expected behaviour. The table has to reflect the requested changes at some point. However, sometimes you may find this mechanism slightly excessive.

For example, if you wrote a custom function that uses several CRUD operations, those CRUD operations will call a render() for each API method. You only need one render at the end, which is sufficient to reflect all the changes. You can treat those combined operations as a single action and let the render wait for them to complete. To do this, use suspend the render to batch the operations.

This can improve the overall performance of the application. Batching several operations can decrease the number of renders, so any API call that ends with a render will benefit from this improvement. It results in less layout trashing, fewer freezes, and a more responsive feel.

There are several API methods you can use for suspending, but batch() is the most universal method. It is a callback function where the render() is executed after all operations provided inside of the body are completed. It is best practice to use this method as it’s safer and easier to use. You just need to place all operations that you want to batch inside a closure. Handsontable takes care of the suspending and performs a single render() at the end.

The following snippet shows a simple example of a few operations batched. Three API operations are called one after another. Without placing them inside the batch callback, every single operation would end with a render(). Thanks to the batching feature, you can skip two renders and end the whole action with one render at the end. This is more optimal, and the gain increases with the number of operations placed inside the batch().

// call the batch method on an instance
hot.batch(() => {
// run the operations as needed
hot.alter('insert_row_above', 5, 45);
hot.setDataAtCell(1, 1, 'x');
hot.selectCell(0, 0);
// the render is executed right after all of the operations are
// completed
});

Suspending the render results in better performance, which is especially noticeable when numerous operations are batched. The diagram shows a comparison where the same operations were performed with (deep blue columns) and without the batch (light blue columns). The gain in speed of execution time increases with the number of operations batched.

batch_operations_comparison

API methods

The following API methods allow suspending:

By using these methods, you can suspend:

  • rendering
  • execution
  • both rendering and the execution.

The term “rendering” refers directly to DOM rendering, and the term “execution” refers to all operations that are different from DOM rendering. Currently, only the indexing recalculation allows you to postpone the process.

Method names that are prefixed with batch\*, i.e., batch(), batchRender(), and batchExecution() are recommended to be used as the first choice if you don’t need to batch async operations. Methods names that are prefixed with suspend\*, i.e., suspendRender() and suspendExecution(), are the second choice. These are useful when you need to batch async operations. Essentially they work the same way as batch\* methods, but the render has to be resumed manually.

batch* methods

batch

This method supsends both rendering and other operations. It is universal and especially useful if you want to batch multiple API calls within the application.

hot.batch(() => {
hot.alter('insert_row_above', 5, 45);
hot.setDataAtCell(1, 1, 'x');
const filters = hot.getPlugin('filters');
filters.addCondition(2, 'contains', ['3']);
filters.filter();
hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
// The table cache will be recalculated, and table render will be
// called once after executing the callback
});

batchRender

The batchRender() method is a callback function. Excessive renders can be skipped by placing the API calls inside it. The table will be rendered after executing the callback. It is less prone to errors as you don’t have to remember to resume the render. The only drawback to this method is that it doesn’t support async operations.

hot.batchRender(() => {
hot.alter('insert_row_above', 5, 45);
hot.setDataAtCell(1, 1, 'x');
// The table will be rendered once after executing the callback
});

batchExecution

The batchExecution() method aggregates multi-line API calls into a callback and postpones the table execution process. After the execution of the operations, the internal table cache is recalculated once. As a result, it improves the performance of wrapped operations. Without batching, a similar case could trigger multiple table cache rebuilds. It is less prone to errors as you don’t have to remember to resume the operations. The only drawback to this method is that it doesn’t support async operations.

hot.batchExecution(() => {
const filters = hot.getPlugin('filters');
filters.addCondition(2, 'contains', ['3']);
filters.filter();
hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
// The table cache will be recalculated once after executing the
// callback
});

suspend* and resume* methods

suspendRender() and resumeRender()

To suspend the rendering process, call the suspendRender() method just before the actions you want to batch. This is a manual approach.

After suspending, resume the process with the resumeRender() method. Every suspendRender() call needs to correspond with one resumeRender() call. For example, if you call suspendRender() 5 times, you need to call resumeRender() 5 times as well.

hot.suspendRender(); // suspend rendering
hot.alter('insert_row_above', 5, 45);
hot.setDataAtCell(1, 1, 'x');
hot.resumeRender(); // remember to resume rendering

suspendExecution and resumeExecution

The suspendExecution() method suspends the execution process. It’s helpful to wrap the table logic changes such as index changes into one call after which the cache is updated. The method is intended to be used by advanced users. Suspending the execution process could cause visual glitches caused by not updating the internal table cache.

To suspend, call suspendExecution() just before the actions you want to batch. This is a manual approach. After suspending, you must remember to resume the process with the resumeExecution() method. In combination, these two methods allow aggregating the table logic changes after which the cache is updated. Resuming the state automatically invokes the table cache updating process.

hot.suspendExecution();
const filters = hot.getPlugin('filters');
filters.addCondition(2, 'contains', ['3']);
filters.filter();
hot.getPlugin('columnSorting').sort({ column: 1, sortOrder: 'desc' });
hot.resumeExecution(); // It updates the cache internally

Live demo of the suspend feature

The following examples show how much the batch() method can decrease the render time. Both of the examples share the same dataset and operations. The first one shows how much time lapsed when the batch() method was used. Run the second example to check how much time it takes to render without the batch() method.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const counter = ref(0);
const output = ref('');
const dataInit: GridSettings['data'] = [
[1, 'Gary Nash', 'Speckled trousers', 'S', 1, 'yes'],
[2, 'Gloria Brown', '100% Stainless sweater', 'M', 2, 'no'],
[3, 'Ronald Carver', 'Sunny T-shirt', 'S', 1, 'no'],
[4, 'Samuel Watkins', 'Floppy socks', 'S', 3, 'no'],
[5, 'Stephanie Huddart', 'Bushy-bush cap', 'XXL', 1, 'no'],
[6, 'Madeline McGillivray', 'Long skirt', 'L', 1, 'no'],
[7, 'Jai Moor', 'Happy dress', 'XS', 1, 'no'],
[8, 'Ben Lower', 'Speckled trousers', 'M', 1, 'no'],
[9, 'Ali Tunbridge', 'Speckled trousers', 'M', 2, 'no'],
[10, 'Archie Galvin', 'Regular shades', 'uni', 10, 'no'],
];
const data2 = [[11, 'Gavin Elle', 'Floppy socks', 'XS', 3, 'yes']];
const data3 = [
[12, 'Gary Erre', 'Happy dress', 'M', 1, 'no'],
[13, 'Anna Moon', 'Unicorn shades', 'uni', 200, 'no'],
[14, 'Elise Eli', 'Regular shades', 'uni', 1, 'no'],
];
const hotSettings = ref<GridSettings>({
data: dataInit,
width: 'auto',
height: 'auto',
colHeaders: ['ID', 'Customer name', 'Product name', 'Size', 'qty', 'Return'],
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function logOutput(msg: string) {
counter.value += 1;
output.value = `[${counter.value}] ${msg}\n${output.value}`;
}
function alterTable() {
const hot = hotRef.value?.hotInstance;
hot?.alter('insert_row_above', 10, 10);
hot?.alter('insert_col_start', 6, 1);
hot?.populateFromArray(10, 0, data2);
hot?.populateFromArray(11, 0, data3);
hot?.setCellMeta(2, 2, 'className', 'green-bg');
hot?.setCellMeta(4, 2, 'className', 'green-bg');
hot?.setCellMeta(5, 2, 'className', 'green-bg');
hot?.setCellMeta(6, 2, 'className', 'green-bg');
hot?.setCellMeta(8, 2, 'className', 'green-bg');
hot?.setCellMeta(9, 2, 'className', 'green-bg');
hot?.setCellMeta(10, 2, 'className', 'green-bg');
hot?.alter('remove_col', 6, 1);
hot?.alter('remove_row', 10, 10);
hot?.setCellMeta(0, 5, 'className', 'red-bg');
hot?.setCellMeta(10, 5, 'className', 'red-bg');
hot?.render();
}
function buttonWithoutClick() {
const t1 = performance.now();
alterTable();
const t2 = performance.now();
logOutput(`Time without batch ${(t2 - t1).toFixed(2)}ms`);
}
function buttonWithClick() {
const hot = hotRef.value?.hotInstance;
const t1 = performance.now();
hot?.batch(alterTable);
const t2 = performance.now();
logOutput(`Time with batch ${(t2 - t1).toFixed(2)}ms`);
}
</script>
<template>
<div id="example1">
<div class="example-controls-container">
<div class="controls">
<button id="buttonWithout" class="button button--primary" @click="buttonWithoutClick">
Run without batch method
</button>
<button id="buttonWith" class="button button--primary" @click="buttonWithClick">
Run with batch method
</button>
</div>
<output class="console" id="output">
{{ output || 'Here you will see the log' }}
</output>
</div>
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</template>

Related guides

Related blog articles

Configuration options

Core methods

Hooks